JUCE: juce::dsp::DelayLine< SampleType, InterpolationType > Class Template Reference

JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Member Functions | List of all members
juce::dsp::DelayLine< SampleType, InterpolationType > Class Template Reference
juce_dsp » processors

A delay line processor featuring several algorithms for the fractional delay calculation, block processing, and sample-by-sample processing useful when modulating the delay in real time or creating a standard delay effect with feedback. More...

`#include <juce_DelayLine.h>`

## Public Member Functions
| DelayLine ()
| Default constructor.
| DelayLine (int maximumDelayInSamples)
| Constructor.
void | setDelay (SampleType newDelayInSamples)
| Sets the delay in samples.
SampleType | getDelay () const
| Returns the current delay in samples.
void | prepare (const ProcessSpec &spec)
| Initialises the processor.
void | setMaximumDelayInSamples (int maxDelayInSamples)
| Sets a new maximum delay in samples.
int | getMaximumDelayInSamples () const noexcept
| Gets the maximum possible delay in samples.
void | reset ()
| Resets the internal state variables of the processor.
void | pushSample (int channel, SampleType sample)
| Pushes a single sample into one channel of the delay line.
SampleType | popSample (int channel, SampleType delayInSamples=-1, bool updateReadPointer=true)
| Pops a single sample from one channel of the delay line.
template<typename ProcessContext >
void | process (const ProcessContext &context) noexcept
| Processes the input and output samples supplied in the processing context.

## Detailed Description

template<typename SampleType, typename InterpolationType = DelayLineInterpolationTypes::Linear>
class juce::dsp::DelayLine< SampleType, InterpolationType >

A delay line processor featuring several algorithms for the fractional delay calculation, block processing, and sample-by-sample processing useful when modulating the delay in real time or creating a standard delay effect with feedback.

Note: If you intend to change the delay in real time, you may want to smooth changes to the delay systematically using either a ramp or a low-pass filter.

See also
  SmoothedValue, FirstOrderTPTFilter

## Constructor & Destructor Documentation

## ◆ DelayLine() [1/2]

template<typename SampleType , typename InterpolationType = DelayLineInterpolationTypes::Linear>

juce::dsp::DelayLine< SampleType, InterpolationType >::DelayLine | ( |  | ) |

Default constructor.

## ◆ DelayLine() [2/2]

template<typename SampleType , typename InterpolationType = DelayLineInterpolationTypes::Linear>

juce::dsp::DelayLine< SampleType, InterpolationType >::DelayLine | ( | int | maximumDelayInSamples | ) |
| explicit

Constructor.

## Member Function Documentation

## ◆ setDelay()

template<typename SampleType , typename InterpolationType = DelayLineInterpolationTypes::Linear>

void juce::dsp::DelayLine< SampleType, InterpolationType >::setDelay | ( | SampleType | newDelayInSamples | ) |

Sets the delay in samples.

## ◆ getDelay()

template<typename SampleType , typename InterpolationType = DelayLineInterpolationTypes::Linear>

SampleType juce::dsp::DelayLine< SampleType, InterpolationType >::getDelay | ( |  | ) | const

Returns the current delay in samples.

## ◆ prepare()

template<typename SampleType , typename InterpolationType = DelayLineInterpolationTypes::Linear>

void juce::dsp::DelayLine< SampleType, InterpolationType >::prepare | ( | const ProcessSpec & | spec | ) |

Initialises the processor.

## ◆ setMaximumDelayInSamples()

template<typename SampleType , typename InterpolationType = DelayLineInterpolationTypes::Linear>

void juce::dsp::DelayLine< SampleType, InterpolationType >::setMaximumDelayInSamples | ( | int | maxDelayInSamples | ) |

Sets a new maximum delay in samples.

Also clears the delay line.

This may allocate internally, so you should never call it from the audio thread.

## ◆ getMaximumDelayInSamples()

template<typename SampleType , typename InterpolationType = DelayLineInterpolationTypes::Linear>

int juce::dsp::DelayLine< SampleType, InterpolationType >::getMaximumDelayInSamples | ( |  | ) | const
| noexcept

Gets the maximum possible delay in samples.

For very short delay times, the result of getMaximumDelayInSamples() may differ from the last value passed to setMaximumDelayInSamples().

## ◆ reset()

template<typename SampleType , typename InterpolationType = DelayLineInterpolationTypes::Linear>

void juce::dsp::DelayLine< SampleType, InterpolationType >::reset | ( |  | ) |

Resets the internal state variables of the processor.

## ◆ pushSample()

template<typename SampleType , typename InterpolationType = DelayLineInterpolationTypes::Linear>

void juce::dsp::DelayLine< SampleType, InterpolationType >::pushSample | ( | int | channel,
|  | SampleType | sample
| ) |  |

Pushes a single sample into one channel of the delay line.

Use this function and popSample instead of process if you need to modulate the delay in real time instead of using a fixed delay value, or if you want to code a delay effect with a feedback loop.

See also
  setDelay, popSample, process

Referenced by juce::dsp::DelayLine< SampleType, InterpolationType >::process().

## ◆ popSample()

template<typename SampleType , typename InterpolationType = DelayLineInterpolationTypes::Linear>

SampleType juce::dsp::DelayLine< SampleType, InterpolationType >::popSample | ( | int | channel,
|  | SampleType | delayInSamples = `-1`,
|  | bool | updateReadPointer = `true`
| ) |  |

Pops a single sample from one channel of the delay line.

Use this function to modulate the delay in real time or implement standard delay effects with feedback.

Parameters

  channel | the target channel for the delay line.
  delayInSamples | sets the wanted fractional delay in samples, or -1 to use the value being used before or set with setDelay function.
  updateReadPointer | should be set to true if you use the function once for each sample, or false if you need multi-tap delay capabilities.

See also
  setDelay, pushSample, process

Referenced by juce::dsp::DelayLine< SampleType, InterpolationType >::process().

## ◆ process()

template<typename SampleType , typename InterpolationType = DelayLineInterpolationTypes::Linear>
template<typename ProcessContext >

void juce::dsp::DelayLine< SampleType, InterpolationType >::process | ( | const ProcessContext & | context | ) |
| noexcept

Processes the input and output samples supplied in the processing context.

Can be used for block processing when the delay is not going to change during processing. The delay must first be set by calling setDelay.

See also
  setDelay

References jassert, juce::dsp::DelayLine< SampleType, InterpolationType >::popSample(), and juce::dsp::DelayLine< SampleType, InterpolationType >::pushSample().

The documentation for this class was generated from the following file:

- juce_DelayLine.h